<?xml version="1.0" encoding="UTF-8"?>
<PlexilPlan xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:tr="extended-plexil-translator">
  <Node NodeType="NodeList">
    <NodeId>DriveToTarget</NodeId>
    <VariableDeclarations>
      <DeclareVariable>
        <Name>drive_done</Name>
        <Type>Boolean</Type>
        <InitialValue>
          <BooleanValue>false</BooleanValue>
        </InitialValue>
      </DeclareVariable>
      <DeclareVariable>
        <Name>timeout</Name>
        <Type>Boolean</Type>
        <InitialValue>
          <BooleanValue>false</BooleanValue>
        </InitialValue>
      </DeclareVariable>
    </VariableDeclarations>
    <NodeBody>
      <NodeList>
        <Node NodeType="Command">
          <NodeId>Drive</NodeId>
          <NodeBody>
            <Command>
              <Name>
                <StringValue>rover_drive</StringValue>
              </Name>
              <Arguments>
                <IntegerValue>10</IntegerValue>
              </Arguments>
            </Command>
          </NodeBody>
        </Node>
        <Node NodeType="NodeList">
          <NodeId>StopForTimeout</NodeId>
          <StartCondition>
            <GE>
              <LookupOnChange>
                <Name>
                  <StringValue>time</StringValue>
                </Name>
              </LookupOnChange>
              <IntegerValue>10</IntegerValue>
            </GE>
          </StartCondition>
          <NodeBody>
            <NodeList>
              <Node NodeType="Command">
                <NodeId>Stop</NodeId>
                <NodeBody>
                  <Command>
                    <Name>
                      <StringValue>rover_stop</StringValue>
                    </Name>
                  </Command>
                </NodeBody>
              </Node>
              <Node NodeType="Assignment">
                <NodeId>SetTimeoutFlag</NodeId>
                <NodeBody>
                  <Assignment>
                    <BooleanVariable>timeout</BooleanVariable>
                    <BooleanRHS>
                      <BooleanValue>true</BooleanValue>
                    </BooleanRHS>
                  </Assignment>
                </NodeBody>
              </Node>
            </NodeList>
          </NodeBody>
        </Node>
        <Node NodeType="NodeList">
          <NodeId>StopForTarget</NodeId>
          <StartCondition>
            <LookupOnChange>
              <Name>
                <StringValue>target_in_view</StringValue>
              </Name>
            </LookupOnChange>
          </StartCondition>
          <SkipCondition>
            <BooleanVariable>timeout</BooleanVariable>
          </SkipCondition>
          <NodeBody>
            <NodeList>
              <Node NodeType="Command">
                <NodeId>Stop</NodeId>
                <NodeBody>
                  <Command>
                    <Name>
                      <StringValue>rover_stop</StringValue>
                    </Name>
                  </Command>
                </NodeBody>
              </Node>
              <Node NodeType="Assignment">
                <NodeId>SetDriveFlag</NodeId>
                <NodeBody>
                  <Assignment>
                    <BooleanVariable>drive_done</BooleanVariable>
                    <BooleanRHS>
                      <BooleanValue>true</BooleanValue>
                    </BooleanRHS>
                  </Assignment>
                </NodeBody>
              </Node>
            </NodeList>
          </NodeBody>
        </Node>
        <Node NodeType="Command">
          <NodeId>TakeNavcam</NodeId>
          <StartCondition>
            <BooleanVariable>timeout</BooleanVariable>
          </StartCondition>
          <SkipCondition>
            <BooleanVariable>drive_done</BooleanVariable>
          </SkipCondition>
          <NodeBody>
            <Command>
              <Name>
                <StringValue>take_navcam</StringValue>
              </Name>
            </Command>
          </NodeBody>
        </Node>
        <Node NodeType="Command">
          <NodeId>TakePancam</NodeId>
          <StartCondition>
            <BooleanVariable>drive_done</BooleanVariable>
          </StartCondition>
          <SkipCondition>
            <BooleanVariable>timeout</BooleanVariable>
          </SkipCondition>
          <NodeBody>
            <Command>
              <Name>
                <StringValue>take_pancam</StringValue>
              </Name>
            </Command>
          </NodeBody>
        </Node>
        <Node NodeType="Command">
          <NodeId>Heater</NodeId>
          <StartCondition>
            <LT>
              <LookupOnChange>
                <Name>
                  <StringValue>temperature</StringValue>
                </Name>
              </LookupOnChange>
              <IntegerValue>0</IntegerValue>
            </LT>
          </StartCondition>
          <SkipCondition>
            <BooleanVariable>timeout</BooleanVariable>
          </SkipCondition>
          <EndCondition>
            <GE>
              <LookupOnChange>
                <Name>
                  <StringValue>temperature</StringValue>
                </Name>
              </LookupOnChange>
              <IntegerValue>10</IntegerValue>
            </GE>
          </EndCondition>
          <RepeatCondition>
            <BooleanValue>true</BooleanValue>
          </RepeatCondition>
          <NodeBody>
            <Command>
              <Name>
                <StringValue>turn_on_heater</StringValue>
              </Name>
            </Command>
          </NodeBody>
        </Node>
      </NodeList>
    </NodeBody>
  </Node>
</PlexilPlan>
